diff -Naur test-for-latech/net/sched/sch_dwcs.c testqf-for-latech/net/sched/sch_dwcs.c
--- test-for-latech/net/sched/sch_dwcs.c	1969-12-31 19:00:00.000000000 -0500
+++ testqf-for-latech/net/sched/sch_dwcs.c	2004-06-11 07:48:00.000000000 -0400
@@ -0,0 +1,1851 @@
+
+/* 
+ * net/sched/sch_dwcs.c   DWCS algorithm scheduler.
+ * 
+ *		This program is free software; you can redistribute it and/or
+ *		modify it under the terms of the GNU General Public License
+ *		as published by the Free Software Foundation; either version
+ *		2 of the License, or (at your option) any later version.
+ * 
+ * Authors:	Gregory Losik <gregor@cc.gatech.edu>
+ *              Christian Poellabauer <chris@cc.gatech.edu>
+ * 		Hasan Abbasi <habbasi@cc.gatech.edu>
+ *		plus a bunch of other students during their
+ *		summer projects/independent projects/etc.
+ *
+ * Known issues: 1) PROC_MONITORING is not inserting new object under /proc FS.
+ *               2) Assumes there are no more then MAX_CONNS classes.  heap.c needs 
+ *                  to be changed to allow greater number.  Max can be 2^16.
+ *               3) The functionality of enabling packet dropping was not tested.
+ * 
+ * Modification: (Hasan Abbasi <habbasi@cc.gatech.edu>
+ * 		1) Fixed bug in dwcs_delete. The root class of the discipline 
+ * 			could be deleted which caused a seg-fault in the kernel
+ * 		2) Modified the dump function to return proper values instead of 
+ * 			limit.
+ * 		3) Added dump_class to display class information. (Same as dump).
+ *		4) Modified the scheduler to wake up the device at the minimum ready time
+ *		   	this required adding two function to the sch_api.c file. 
+ *			However the functions have been kept very generic and can be used by all qdiscs
+ *		5)  Add Best effor queuing to the default class. If the deadline of the the stream
+ *			is -1, insert it into the default class (same with non classified packets).
+ *			Modify the default class to exhibit queue like behaviour. Not so hard to do actually. 
+ *		7) Modified the enqueue functions to handle slow streams. Normally the deadline for an empty queue was modified
+ *			in such a way that a slow stream was not actually deadline constrained at the kernel level. This has been fixed
+ *
+ *		8) Added support for sending fragmented data at the scheduler level. This is tricky and relies on the usage of qsockets. 
+ * 			When multiple fragments are to be sent with the same deadline we don't want to update teh deadline until the last 
+ *			fragment for a data packet has been sent. 
+ * 
+ *		9) FIXME: Add a new structure to support setting up qdics without using rtattrs. This will make life soo much simpler when
+ *			we generalize qsockets.
+ * 		
+ */
+
+#define GREGORY					/* debugging message to get generall list of data */
+#define GREGORY_DETAILS			/* low leve debuggin message */
+#define GREGORY_TRACE			/* tells the association between sk_buff and classes */
+
+
+#define OVRHD           0		// GL: Not sure what it is... ????
+#define DROP_ON         1		// GL: Not sure what it is... ???? lets remove it.
+#define PROC_MONITORING			// GL: Define this to have /proc/ entry for status monitoring.
+
+
+
+#include <linux/config.h>
+#include <linux/module.h>
+#include <asm/uaccess.h>
+#include <asm/system.h>
+#include <asm/bitops.h>
+#include <linux/types.h>
+#include <linux/kernel.h>
+#include <linux/sched.h>
+#include <linux/string.h>
+#include <linux/mm.h>
+#include <linux/socket.h>
+#include <linux/sockios.h>
+#include <linux/in.h>
+#include <linux/errno.h>
+#include <linux/interrupt.h>
+#include <linux/if_ether.h>
+#include <linux/inet.h>
+#include <linux/netdevice.h>
+#include <linux/etherdevice.h>
+#include <linux/notifier.h>
+#include <net/ip.h>
+#include <net/route.h>
+#include <linux/skbuff.h>
+#include <net/sock.h>
+#include <net/pkt_sched.h>
+#include <linux/proc_fs.h>
+#include <linux/unistd.h>
+
+//#include <sys/syscall.h>
+#include <asm/unistd.h>
+#include <asm/uaccess.h>
+
+
+#include "heap.c"
+
+extern void * sys_call_table[];
+
+int (*pidcall)(void);
+
+
+
+#ifdef PROC_MONITORING
+int                 proc_read_dwcs ( char *,
+									 char **,
+									 off_t,
+									 int,
+									 int *,
+									 void * );
+
+// struct proc_dir_entry proc_dwcs;
+#endif
+
+static __inline__ struct dwcs_class *dwcs_class_lookup ( struct
+														 dwcs_sched_data *,
+														 u32 );
+static void         dwcs_destroy_class ( struct dwcs_class * );
+static void         dwcs_link_class ( struct dwcs_class * );
+static void         dwcs_destroy_filters ( struct dwcs_class * );
+
+
+static inline unsigned long tvtojiffies(struct timeval *value)
+{
+	unsigned long sec = (unsigned) value->tv_sec;
+	unsigned long usec = (unsigned) value->tv_usec;
+
+	if (sec > (ULONG_MAX / HZ))
+		return ULONG_MAX;
+	usec += 1000000 / HZ - 1;
+	usec /= 1000000 / HZ;
+	return HZ*sec+usec;
+}
+
+
+/* 
+** the hash function for indexing dwcs_sched_data->classes[] array.  It
+** _must_ return a value in [0,16] range.
+*/
+static __inline__ unsigned
+dwcs_hash ( u32 h )
+{
+	h ^= h >> 8;
+	h ^= h >> 4;
+	return h & 0xF;
+}
+
+void watchdog(unsigned long arg)
+{
+	struct net_device *dev = (struct net_device *) arg;
+	if (dev)
+	{
+		netif_schedule(dev);
+	}
+}
+
+void dwcs_init_timer(struct timer_list *wd_timer, struct net_device *dev)
+{
+	init_timer(wd_timer);
+	wd_timer->function = watchdog;
+	wd_timer->data = (unsigned long) dev;
+}
+
+/* 
+ * The drop function is used to drop a packet from the
+ * queue.
+ */
+static int
+dwcs_drop ( struct Qdisc *sch )
+{
+	struct sk_buff     *skb;
+
+	skb = __skb_dequeue_tail ( &sch->q );
+	if ( skb )
+	{
+		sch->stats.backlog -= skb->len;
+		printk(KERN_ERR "dropping packet\n");
+		kfree_skb ( skb );
+		return 1;
+	}
+	return 0;
+
+}
+
+
+/*
+ * The reset function of a queuing discipline is used to reset the 
+ * queuing discipline to its innitial state.  It clears all queuing 
+ * disciplines, timers are stopped, etc.
+ */
+static void
+dwcs_reset ( struct Qdisc *sch )
+{
+	skb_queue_purge ( &sch->q );
+	sch->stats.backlog = 0;
+}
+
+
+/*
+ * No documentation on ..._reclassify() was found, but it relates
+ * to "policer"
+ */
+static struct dwcs_class *
+dwcs_reclassify ( struct sk_buff *skb,
+				  struct dwcs_class *this )
+{
+	return NULL;
+}
+
+
+
+/*
+ * A helper function that tries to return the address of a
+ * class to which "skb" should belong.  Returns NULL
+ * if can not be determined, and then packet usually gets 
+ * dropped, or assigned to some "default" class.
+ */
+static struct dwcs_class *
+dwcs_classify ( struct sk_buff *skb,
+				struct Qdisc *sch )
+{
+
+	struct dwcs_sched_data *q = ( struct dwcs_sched_data * ) sch->data;
+	struct dwcs_class  *head = q->link;
+	struct dwcs_class  *cl = NULL;
+	struct tcf_result   res;
+	int                 result = 0;
+
+	/*
+	 * tc_classify() calls each filter in a list, in order of priority and protocol id, 
+	 * * and returns the result in 'res' structure 
+	 */
+	if ( !head->filter_list
+		 || ( result = tc_classify ( skb, head->filter_list, &res ) ) < 0 )
+		goto fallback;
+
+	if ( ( cl = ( void * ) res.class ) == NULL )
+	{
+		if ( TC_H_MAJ ( res.classid ) )
+			cl = dwcs_class_lookup ( q, res.classid );
+
+		if ( cl == NULL )
+			goto fallback;
+
+	}
+
+	return cl;
+
+  fallback:
+	return head;
+}
+
+
+/*
+ * The enqueue function enqueues a packet with the queueing discipline.
+ * In our case, we basically first call classifier function, which in 
+ * turn does most of the work and returns the pointer of a class
+ * on which packet should be enqueued.
+ */
+static int
+dwcs_enqueue ( struct sk_buff *skb,
+			   struct Qdisc *sch )
+{
+	struct dwcs_sched_data *q = ( struct dwcs_sched_data * ) sch->data;
+	struct dwcs_class  	*cl;
+	struct sock			*sk = NULL;
+	int		 			ret =  NET_XMIT_POLICED;
+	
+	cl = dwcs_classify ( skb, sch );
+
+#ifdef CONFIG_NET_CLS_POLICE
+	q->rx_class = cl;
+#endif
+
+	if ( cl )
+	{
+#ifdef CONFIG_NET_CLS_POLICE
+		cl->q->__parent = sch;
+#endif
+		if(skb)
+		{
+			sk = skb->sk;
+			skb->urgent_flag = jiffies;
+			if(sk)
+			{
+				skb->drop_flag = sk->drop_flag;
+			
+				if(sk->fragments == 0)
+				{
+					//initial fragment
+					skb->fragments = 0;
+					sk->fragments = 1;
+				}
+				else if(sk->fragments == 1)
+				{
+					skb->fragments = 1;
+				}
+				else
+					skb->fragments = 0;
+			}
+		
+		}
+
+		if(cl == q->link)
+		{
+			/*link class - this is the best effort class - the packet didn't ge
+			 *classified
+			 */
+			if((ret = cl->q->enqueue (skb, cl->q)) == 0)
+			{
+				/*queue the packet into the default class*/
+				
+				sch->q.qlen ++;
+				sch->stats.packets++;
+				sch->stats.bytes += skb->len;
+
+				/*we donot put the class into any of the heaps*/
+				mod_timer ( &q->wd_timer, jiffies );
+				
+				return 0;
+				
+			}
+			else
+			{
+				sch->stats.drops++;
+
+				kfree_skb ( skb );
+				if(cl != NULL);
+				{
+					cl->stats.drops++;
+				}
+				return ret;
+				
+			}
+	
+		}
+		else 
+		{
+			
+			if ((ret = cl->q->enqueue ( skb, cl->q )) == 0)
+			{
+				
+				sch->q.qlen++;
+				sch->stats.packets++;
+				sch->stats.bytes += skb->len;
+
+				/*
+				 * DWCS specific initialization 
+				 */
+				if ( cl->q->q.qlen == 1 )
+				{				// is it a head packet?
+					struct lt_heap      tmp_heap;
+
+					if(cl->attr.deadline == -1)
+					{
+						cl->attr.deadline = jiffies + cl->attr.ipg;	// GL: init deadline attribute
+					}
+				
+					if(cl->attr.readytime == -1)
+					{
+						cl->attr.readytime = jiffies;
+					}
+
+					while(cl->attr.deadline < jiffies)
+					{
+						cl->attr.late++;
+						cl->attr.wlate++;
+						if ( cl->attr.sent + cl->attr.late == cl->attr.window )
+						{
+							cl->attr.window += cl->attr.old;
+							if ( cl->attr.wlate > cl->attr.oln )
+							{
+								cl->attr.violations++;
+							}
+							cl->attr.wlate = 0;
+						}
+						cl->attr.deadline += ( cl->attr.ipg + OVRHD );
+						cl->attr.readytime += (cl->attr.ipg + OVRHD );
+						if ( cl->attr.cln > 0 )
+						{
+							cl->attr.cln--;
+							cl->attr.cld--;
+							if ( ( cl->attr.cld == 0 )
+								 && ( cl->attr.cln == 0 ) )
+							{
+								cl->attr.cln = cl->attr.oln;
+								cl->attr.cld = cl->attr.old;
+							}
+						}
+						else
+						{
+							if ( cl->attr.oln == 0 )
+								cl->attr.cld += cl->attr.old;
+							else
+							{
+								cl->attr.cln = 2 * ( cl->attr.oln ) - 1;
+								cl->attr.cld =
+									2 * ( cl->attr.old ) + ( cl->attr.cld -
+															 1 );
+							}
+						}
+						cl->attr.clt =
+							( cl->attr.cld == 0) ? 0.0 : ( float ) cl->attr.cln / cl->attr.cld;
+						
+					}
+					
+
+					if ( cl->attr.flags != DWCS_WORK_CONS )
+					{
+						/*
+						 * Insert head packet into deadline heap if deadline constrained 
+						 */
+						q->slheap_size++;
+						HInsert3 ( q->slheap, cl->classid,
+								   cl->attr.readytime,
+								   q->slheap_size );
+
+					}
+					else
+					{
+						q->dlheap_size++;
+						HInsert ( q->dlheap, cl->classid,
+								  cl->attr.deadline,
+								  q->dlheap_size );
+
+						/*
+						 * Insert head packet into loss-tolerance heap. 
+						 */
+						tmp_heap.clt = cl->attr.clt;
+						tmp_heap.stream = cl->classid;
+						tmp_heap.deadline = cl->attr.deadline;
+						tmp_heap.cln = cl->attr.cln;
+						tmp_heap.cld = cl->attr.cld;
+						tmp_heap.oln = cl->attr.oln;
+						// tmp_heap.old      = cl->attr.old;
+						tmp_heap.wlate = cl->attr.wlate;
+
+						/*
+						 * this one is tvtojiffies() from kernel/itimer.c 
+						 */
+						tmp_heap.arr_time = tvtojiffies(&(skb->stamp));
+
+						q->ltheap_size++;
+						HInsert2 ( q->ltheap, tmp_heap,
+								   q->ltheap_size );
+					}
+				}
+
+/*MHA: If there are any packets in the sleep heap
+ * set the timer to go off at the minimum ready time
+ * this gurantees that the packet will be sent 
+ * after ready time but before deadline
+ * even on a non busy link 
+ */
+	
+				if ( q->slheap_size > 0)
+					mod_timer ( &q->wd_timer, q->slheap[0].readytime );
+
+				return 0;
+			}
+			else
+			{
+				sch->stats.drops++;
+				if(cl == NULL)
+					kfree_skb ( skb );
+				if(cl != NULL);
+				{
+					cl->stats.drops++;
+				}
+
+				return ret;
+			}
+		}
+		
+	}
+	
+	/*
+	 * The dwcs_classify() has failed to classify the packet,
+	 * so we are dropping it. Theoretically, this should never 
+	 * happen in our case because we have default class for 
+	 * this: q->link.  However if this class gets explicitly 
+	 * deleted, by the user, we need to drop the packet.
+	 */
+	sch->stats.drops++;
+	if(cl == NULL)
+		kfree_skb ( skb );
+	if(cl != NULL);
+	{
+		cl->stats.drops++;
+	}
+
+	return ret;
+}
+
+
+
+/*
+ * The requeue function of a queuing discipline requeues a packet for 
+ * transmission.  After dequeueing the packet, if for some reason, the 
+ * packet is not transmitted, the packet needs to be put back in the 
+ * queue at the same position from where it was dequeued.
+ *
+ * (needs to be finished since it doesn't run filters/classifiers, 
+ *  but then I also never seen this function beeing called by a kernel.)
+ */
+static int
+dwcs_requeue ( struct sk_buff *skb,
+			   struct Qdisc *sch )
+{
+	printk(KERN_ERR "in dwcs_requeue\n");
+	kfree_skb(skb);
+	return NET_XMIT_CN;
+
+}
+
+
+
+
+/*
+ * The dequeue function dequeues a packet for sending.  It returns the next 
+ * packet that needs to be sent out on the output interface.  This packet 
+ * is determined by the scheduler in the queuing discipline.
+ * In our case we currently have something simmmilar to round-ribin 
+ * scheduling algorithm, but this will be replaced by DWCS.
+ */
+static struct sk_buff *
+dwcs_dequeue ( struct Qdisc *sch )
+{
+	struct sk_buff     *skb = NULL;
+	struct sk_buff     *result = NULL;
+	struct dwcs_sched_data *q = ( struct dwcs_sched_data * ) sch->data;
+
+	struct lt_heap      tmp_heap;
+	int                 flag;
+	int                 not_drop_flag = FALSE;
+	u32                 classid = 0;
+	u32                 min_classid_index = 0;
+	struct dwcs_class  *cl = NULL;
+	struct dwcs_class  *tmp_cl = NULL;
+	struct dwcs_class  *sl_cl = NULL;
+	u32					qlen;
+	struct sl_heap      temp_slheap;
+
+
+	result = NULL;
+
+
+	/*
+	 * are there any packets to send? 
+	 */
+	if ( !sch->q.qlen )
+		return result;
+
+	qlen = sch->q.qlen;
+	
+/* MHA: Move all sleeping streams from the sleep heap 
+ * to the deadline and lt heaps
+ * but only if the readytime is less then jiffies 
+ * (ready time has elapsed)
+ */
+
+	while ( q->slheap_size > 0 && ( jiffies >= q->slheap[0].readytime ) )
+	{
+		temp_slheap = q->slheap[0];
+		sl_cl = dwcs_class_lookup ( q, q->slheap[0].stream );
+
+		if ( sl_cl != NULL )
+		{
+			q->dlheap_size++;
+			HInsert ( q->dlheap, q->slheap[0].stream,
+					  sl_cl->attr.deadline, q->dlheap_size );
+			skb = skb_peek ( &sl_cl->q->q );	// gets the pointer to a packet at the head.
+			tmp_heap.clt = sl_cl->attr.clt;
+			tmp_heap.stream = sl_cl->classid;
+			tmp_heap.deadline = sl_cl->attr.deadline;
+			tmp_heap.cln = sl_cl->attr.cln;
+			tmp_heap.cld = sl_cl->attr.cld;
+			tmp_heap.oln = sl_cl->attr.oln;
+			// tmp_heap.old      = tmp_cl->attr.old;
+			tmp_heap.wlate = sl_cl->attr.wlate;
+
+			tmp_heap.arr_time = tvtojiffies(&(skb->stamp));
+
+			q->ltheap_size++;
+			HInsert2 ( q->ltheap, tmp_heap, q->ltheap_size );
+
+			q->slheap_size--;
+			HExtractMin3 ( q->slheap, q->slheap_size );
+		}
+		else
+		{
+			q->slheap_size--;
+			HExtractMin3 ( q->slheap, q->slheap_size );
+		}
+	}
+	skb = NULL;
+	result = NULL;
+	sl_cl = NULL;
+
+/*MHA: the flag is a bit suspect. I think its an 
+ *artifact of some older code
+ */
+	flag = TRUE;
+	while ( flag )
+	{
+
+/*Check to see if the deadline of the heap can be met
+ * if the deadline cannot be met
+ * we can either drop the packet or perhaps still send it late
+ */
+
+		if ( ( q->dlheap_size > 0 ) && ( jiffies > q->dlheap[0].deadline ) )
+		{
+			classid = q->dlheap[0].stream;
+			printk(KERN_ERR " Missed deadline - deadline = %ld jiffies = %ld\n", q->dlheap[0].deadline, jiffies);
+
+			cl = dwcs_class_lookup ( q, classid );
+			if(cl)
+			{
+					
+				while ( cl && ( jiffies > cl->attr.deadline ) )
+				{
+					/*Update the deadline missed statistics - this is a bit strange and 
+					 *requires an explanation. For each ipg that jiffies is greater
+					 *then deadline by - we need to update teh deadline missed stats
+					 *since this is stream based
+					 */
+					cl->attr.late++;
+					cl->attr.wlate++;
+					if ( cl->attr.sent + cl->attr.late == cl->attr.window )
+					{
+						cl->attr.window += cl->attr.old;
+						if ( cl->attr.wlate > cl->attr.oln )
+						{
+							cl->attr.violations++;
+						}
+						cl->attr.wlate = 0;
+					}
+					cl->attr.deadline += ( cl->attr.ipg + OVRHD );
+					cl->attr.readytime += (cl->attr.ipg + OVRHD );
+					if ( cl->attr.cln > 0 )
+					{
+						cl->attr.cln--;
+						cl->attr.cld--;
+						if ( ( cl->attr.cld == 0 )
+							 && ( cl->attr.cln == 0 ) )
+						{
+							cl->attr.cln = cl->attr.oln;
+							cl->attr.cld = cl->attr.old;
+						}
+					}
+					else
+					{
+						if ( cl->attr.oln == 0 )
+							cl->attr.cld += cl->attr.old;
+						else
+						{
+							cl->attr.cln = 2 * ( cl->attr.oln ) - 1;
+							cl->attr.cld =
+								2 * ( cl->attr.old ) + ( cl->attr.cld -
+														 1 );
+						}
+					}
+				}				// end of "while ( (cl) && ( jiffies > cl->attr.deadline ) ) {"
+
+				cl->attr.clt =
+					( cl->attr.cld == 0) ? 0.0 : ( float ) cl->attr.cln / cl->attr.cld;
+				
+#ifdef DROP_ON
+				if(cl->attr.droppable !=  DWCS_NON_DROPPABLE)
+				{
+					/*ok this is if the stream supports dropppable packets
+					 *this needs to be added to the dwcs parameters obviously
+					 *There are three possible scenarios
+					 *	1) Stream is nondroppable packet is non droppable - don't drop anything
+					 *	2) Stream is nondroppable packet is droppable - erm.. don't know what to do
+					 *	3) Stream is droppable packet is non droppable - don't drop the packet
+					 *	4) Stream is droppable packet is droppable - drop away
+					 */
+					skb = skb_peek ( &cl->q->q );	// gets the pointer to a packet at the head.
+
+					if(skb && skb->drop_flag == DWCS_NON_DROPPABLE)
+					{
+						dwcs_drop ( cl->q );
+						printk("dropped late packet\n");
+						sch->q.qlen --;
+						q->ltheap_size--;
+						HDelete2 ( q->ltheap, classid, q->ltheap_size );
+						q->dlheap_size--;
+						HExtractMin ( q->dlheap, q->dlheap_size );
+						not_drop_flag = FALSE;
+						cl->attr.deadline += cl->attr.ipg;	// GL: init deadline attribute
+						cl->attr.readytime += ( cl->attr.ipg + OVRHD );
+
+						/*
+						 * insert new packet into both heaps. 
+						 */
+						if ( cl->q->q.qlen > 0 )
+						{
+							if ( cl->attr.flags != DWCS_WORK_CONS )
+							{
+
+								q->slheap_size++;
+								HInsert3 ( q->slheap, classid,
+										   cl->attr.readytime,
+										   q->slheap_size );
+							}
+							else
+							{
+								skb = skb_peek ( &cl->q->q );	// gets the pointer to a packet at the head.
+								if(skb != NULL)
+								{
+									
+									q->dlheap_size++;
+									q->ltheap_size++;
+
+									HInsert ( q->dlheap, classid, cl->attr.deadline,
+											  q->dlheap_size );
+									tmp_heap.clt = cl->attr.clt;
+									tmp_heap.stream = classid;
+									tmp_heap.deadline = cl->attr.deadline;
+									tmp_heap.cln = cl->attr.cln;
+									tmp_heap.cld = cl->attr.cld;
+									tmp_heap.oln = cl->attr.oln;
+									// tmp_heap.old      = cl->attr.old;
+									tmp_heap.wlate = cl->attr.wlate;
+									tmp_heap.arr_time = tvtojiffies(&(skb->stamp));
+									HInsert2 ( q->ltheap, tmp_heap, q->ltheap_size );
+								}
+							}
+						}
+					}
+					else
+					{
+						not_drop_flag = TRUE;
+						flag = FALSE;
+					}
+				}
+				else
+				{
+					not_drop_flag = TRUE;
+					flag = FALSE;
+				}
+#else
+				not_drop_flag = TRUE;
+				flag = FALSE;
+#endif
+			}
+		}
+		else
+		{
+			flag = FALSE;
+	
+			if ( not_drop_flag == TRUE )
+			{
+				cl = dwcs_class_lookup(q, q->dlheap[0].stream);
+				q->dlheap_size --;
+				q->ltheap_size --;
+				HExtractMin ( q->dlheap, q->dlheap_size );
+				HDelete2 ( q->ltheap, classid, q->ltheap_size );
+				skb = skb_peek ( &cl->q->q );	// gets the pointer to a packet at the head.
+				if(skb != NULL)
+				{
+
+					cl->attr.deadline += cl->attr.ipg;	// GL: init deadline attribute ???? do we need it???
+					cl->attr.readytime += cl->attr.ipg;
+					q->dlheap_size ++;
+					q->ltheap_size ++;
+					HInsert ( q->dlheap, classid, cl->attr.deadline,
+							  q->dlheap_size );
+					tmp_heap.clt = cl->attr.clt;
+					tmp_heap.stream = classid;
+					tmp_heap.deadline = cl->attr.deadline;
+					tmp_heap.cln = cl->attr.cln;
+					tmp_heap.cld = cl->attr.cld;
+					tmp_heap.oln = cl->attr.oln;
+					// tmp_heap.old      = cl->attr.old;
+					tmp_heap.wlate = cl->attr.wlate;
+					/*
+					 * this one is tvtojiffies() from kernel/itimer.c 
+					 */
+					tmp_heap.arr_time = tvtojiffies(&(skb->stamp));
+					HInsert2 ( q->ltheap, tmp_heap, q->ltheap_size );
+				}
+				skb = NULL;
+				
+			}
+			not_drop_flag = FALSE;
+		}					// end of " } else { "
+
+
+		/*
+		 * Send first element in loss tolerance heap. 
+		 */
+
+		if ( q->ltheap_size > 0 )
+		{
+			min_classid_index = q->ltheap[0].stream;
+			tmp_cl = dwcs_class_lookup ( q, min_classid_index );
+		}
+		else
+		{
+			tmp_cl = NULL;
+		}
+
+		if ( tmp_cl && ( tmp_cl->q->q.qlen > 0 ) )
+		{
+			if ( ( tmp_cl->attr.cld > tmp_cl->attr.cln )
+				 && ( tmp_cl->attr.deadline != -1 ) )
+				tmp_cl->attr.cld--;
+		
+			if ( ( tmp_cl->attr.cld == 0 ) && ( tmp_cl->attr.cln == 0 ) )
+			{
+				tmp_cl->attr.cln = tmp_cl->attr.oln;
+				tmp_cl->attr.cld = tmp_cl->attr.old;
+			}
+
+			tmp_cl->attr.clt = ( tmp_cl->attr.cld == 0 ) ? 0.0 :
+				( float ) tmp_cl->attr.cln / tmp_cl->attr.cld;
+
+			tmp_cl->attr.sent++;
+			if ( tmp_cl->attr.sent + tmp_cl->attr.late ==
+				 tmp_cl->attr.window )
+			{
+				tmp_cl->attr.window += tmp_cl->attr.old;
+				if ( tmp_cl->attr.wlate > tmp_cl->attr.oln )
+				{
+					tmp_cl->attr.violations++;
+				}
+				tmp_cl->attr.wlate = 0;
+			}
+
+
+			/*
+			 * Original implementation would send the packet now.
+			 * * We instead deque the packet from class's internal
+			 * * queue, and save the pointer to it.  
+			 */
+			result = tmp_cl->q->dequeue ( tmp_cl->q );
+				
+			if(result)
+			{
+
+				tmp_cl->attr.bytes += result->len;	/* Length of actuall data */
+				// DStats ( .... );
+
+				/*
+				 * Remove sent packet from deadline heap 
+				 */
+				q->dlheap_size--;
+				HDelete ( q->dlheap, min_classid_index,
+						  q->dlheap_size );
+				
+				q->ltheap_size--;
+				HExtractMin2 ( q->ltheap, q->ltheap_size );
+
+				/*
+				 * Insert next packet in stream if queue non-empty 
+				 */
+				if ( tmp_cl->q->q.qlen > 0 )
+				{
+
+					skb = skb_peek(&tmp_cl->q->q);
+					
+					if(result->fragments == 0 || result->fragments == 1)
+					{
+						if(!(skb && skb->fragments == 1))
+						{
+							tmp_cl->attr.deadline += ( tmp_cl->attr.ipg + OVRHD );
+							tmp_cl->attr.readytime += ( tmp_cl->attr.ipg + OVRHD );
+						}
+					}
+					else
+					{
+						tmp_cl->attr.deadline += ( tmp_cl->attr.ipg + OVRHD );
+						tmp_cl->attr.readytime += ( tmp_cl->attr.ipg + OVRHD );
+					}
+
+					if ( tmp_cl->attr.flags != DWCS_WORK_CONS )
+					{
+						q->slheap_size++;
+						HInsert3 ( q->slheap, min_classid_index,
+								   tmp_cl->attr.readytime,
+								   q->slheap_size );
+
+					}
+					else
+					{
+						skb = skb_peek(&tmp_cl->q->q);
+						if(!skb)
+							printk("SKB == NULL\n");
+						
+						q->dlheap_size++;
+						HInsert ( q->dlheap, min_classid_index,
+								  tmp_cl->attr.deadline,
+								  q->dlheap_size );
+						
+						q->ltheap_size++;
+
+						tmp_heap.clt = tmp_cl->attr.clt;
+						tmp_heap.stream = min_classid_index;
+						tmp_heap.deadline = tmp_cl->attr.deadline;
+						tmp_heap.cln = tmp_cl->attr.cln;
+						tmp_heap.cld = tmp_cl->attr.cld;
+						tmp_heap.oln = tmp_cl->attr.oln;
+						tmp_heap.wlate = tmp_cl->attr.wlate;
+						/*
+						 * this one is tvtojiffies() from kernel/itimer.c 
+						 */
+						if(skb)
+							tmp_heap.arr_time = tvtojiffies(&(skb->stamp));
+
+						HInsert2 ( q->ltheap, tmp_heap, q->ltheap_size );
+					}
+				}
+				
+			}
+
+		}					// end of "if ((tmp_cl->attr.cld > tmp_cl->attr.cln) && (tmp_cl->attr.deadline != -1)) "
+
+	}							// end of "while (flag)"
+	
+
+
+	if ( result )
+	{
+		tmp_cl->attr.delay += (jiffies - result->urgent_flag);
+		sch->q.qlen--;
+	}
+	else
+	{
+		if(q->link && q->link->q && q->link->q->q.qlen > 0)
+			result = q->link->q->dequeue ( q->link->q );
+		if(result)
+		{
+			q->link->attr.sent ++;
+			q->link->attr.delay += (jiffies - result->urgent_flag);
+			sch->q.qlen --;
+		}
+	}
+
+	if ( q->slheap_size > 0)
+		mod_timer ( &q->wd_timer, q->slheap[0].readytime );
+
+
+	return result;
+}
+
+
+
+/*
+ * The init function of a queuing discipline is used to initialize and configure 
+ * the parameters of a queuing discipline when it is created.
+ */
+static int
+dwcs_init ( struct Qdisc *sch,
+			struct rtattr *opt )
+{
+	struct dwcs_sched_data *q = ( void * ) sch->data;
+	struct rtattr      *tb[TCA_DWCS_MAX];
+
+	MOD_INC_USE_COUNT;			/* indicate that the module is in use */
+
+	/*
+	 * initialization of DWCS two heaps 
+	 */
+	if ( opt == NULL )
+		return 0;
+
+	q->dlheap_size = 0;
+	q->ltheap_size = 0;
+
+	/*
+	 * initialize default class "q->link" 
+	 */
+	q->link =
+		( struct dwcs_class * ) kmalloc ( sizeof ( struct dwcs_class ),
+										  GFP_KERNEL );
+	if ( q->link == NULL )
+		return -ENOBUFS;
+
+	q->link->filter_list = NULL;
+	q->link->refcnt = 1;
+	q->link->classid = sch->handle;
+	q->link->qdisc = sch;
+	if ( !( q->link->q = qdisc_create_dflt ( sch->dev, &pfifo_qdisc_ops ) ) )
+		q->link->q = &noop_qdisc;
+
+
+	/*
+	 * Process passed parameters here - We apply them to a 
+	 * * default class: 'sch->data->link' 
+	 */
+	if ( opt == NULL ||
+		 rtattr_parse ( tb, TCA_DWCS_MAX, RTA_DATA ( opt ),
+						RTA_PAYLOAD ( opt ) ) )
+		return -EINVAL;
+
+	if ( tb[TCA_DWCS_DEADLINE - 1] &&
+		 RTA_PAYLOAD ( tb[TCA_DWCS_DEADLINE - 1] ) != 4 )
+		return -EINVAL;
+
+	if ( tb[TCA_DWCS_OLN - 1] && RTA_PAYLOAD ( tb[TCA_DWCS_OLN - 1] ) != 4 )
+		return -EINVAL;
+
+	if ( tb[TCA_DWCS_OLD - 1] && RTA_PAYLOAD ( tb[TCA_DWCS_OLD - 1] ) != 4 )
+		return -EINVAL;
+
+	if ( tb[TCA_DWCS_FLAGS - 1] &&
+		 RTA_PAYLOAD ( tb[TCA_DWCS_FLAGS - 1] ) != 4 )
+		return -EINVAL;
+
+	if ( tb[TCA_DWCS_DEADLINE - 1] )
+		q->link->attr.ipg =
+			*( long * ) RTA_DATA ( tb[TCA_DWCS_DEADLINE - 1] );
+	// q->link->attr.deadline = *(long*)RTA_DATA(tb[TCA_DWCS_DEADLINE-1]);
+	if ( tb[TCA_DWCS_OLN - 1] )
+		q->link->attr.oln =
+			*( unsigned int * ) RTA_DATA ( tb[TCA_DWCS_OLN - 1] );
+	if ( tb[TCA_DWCS_OLD - 1] )
+	{
+		q->link->attr.old =
+			*( unsigned int * ) RTA_DATA ( tb[TCA_DWCS_OLD - 1] );
+		if ( q->link->attr.old == 0 )
+			return -EINVAL;
+	}
+	/*
+	 * process optional DWCS parameters 
+	 */
+	if ( tb[TCA_DWCS_FLAGS - 1] )
+		q->link->attr.flags =
+			*( unsigned int * ) RTA_DATA ( tb[TCA_DWCS_FLAGS - 1] );
+	q->link->attr.cln = 0;		/* Current loss numerator. */
+	q->link->attr.cld = 0;		/* Current loss denominator. */
+	q->link->attr.droppable = FALSE;	/* TRUE if packets can be dropped */
+	q->link->attr.cln = q->link->attr.oln;
+	q->link->attr.cld = q->link->attr.old;
+	q->link->attr.clt = ( ( float ) q->link->attr.oln ) / q->link->attr.old;
+
+
+	/*
+	 * now, even though the q->link is our static, always existing class for
+	 * * unmatched packets, we still add it to q->classes[] array for consistency.
+	 * * q->classes[] is array/hash of all existing classes.
+	 */
+	dwcs_link_class ( q->link );
+
+	q->classcount = 1;			/* number of classes; one is always created as default */
+
+
+	/*
+	 * if (opt == NULL) {
+	 * if (sch->ops == &bdwcs_qdisc_ops)
+	 * q->limit = sch->dev->tx_queue_len*sch->dev->mtu;
+	 * else 
+	 * q->limit = sch->dev->tx_queue_len;
+	 * } else {
+	 * struct tc_dwcs_qopt *ctl = RTA_DATA(opt);
+	 * if (opt->rta_len < RTA_LENGTH(sizeof(*ctl)))
+	 * return -EINVAL;
+	 * q->limit = ctl->limit;
+	 * }
+	 */
+
+	if(sch->dev == NULL)
+		printk("dev == NULL\n");
+	else 
+		dwcs_init_timer ( &q->wd_timer, sch->dev );
+
+
+#ifdef PROC_MONITORING
+	/*
+	 * Create /proc/ file entry 
+	 */
+	// proc_register(&proc_root, &proc_dwcs);
+	q->ent = create_proc_entry ( "net/sch_dwcs", 0, 0 );
+	q->ent->read_proc = proc_read_dwcs;
+#endif
+
+	return 0;
+}
+
+
+int
+dwcs_copy_xstats ( struct sk_buff *skb,
+				   struct tc_stats *st )
+{
+	RTA_PUT ( skb, TCA_XSTATS, sizeof ( *st ), st );
+	return 0;
+
+  rtattr_failure:
+	return -1;
+}
+
+
+
+/*
+ * The dump function is used to dump diagnostic data associated with a 
+ * queuing discipline.
+ */
+#ifdef CONFIG_RTNETLINK
+static int
+dwcs_dump ( struct Qdisc *sch,
+			struct sk_buff *skb )
+{
+	struct dwcs_sched_data *q = ( struct dwcs_sched_data * ) sch->data;
+	int                 ipg = 0,
+		oln = 0,
+		old = 0;
+	struct rtattr      *rta = NULL;
+	unsigned char      *b = skb->tail;
+
+	rta = ( struct rtattr * ) b;
+
+#ifdef GREGORY_DETAILS
+	/*
+	 * tell how many classes there are 
+	 */
+	{
+		struct dwcs_class  *tmp = NULL;
+		int                 count = 0,
+			i,
+			f_count = 0;
+		struct tcf_proto   *ptr = NULL;
+
+
+		for ( i = 0; i < 16; i++ )
+		{
+			tmp = q->classes[i];
+			while ( tmp )
+			{
+				count++;
+				tmp = tmp->next;
+			}
+		}
+
+		/*
+		 * Count how many filters there are 
+		 */
+		if ( q->link )
+			for ( ptr = q->link->filter_list; ptr; ptr = ptr->next )
+			{
+				f_count++;
+			}
+
+	}
+#endif
+
+	//opt.limit = q->limit;
+	//RTA_PUT(skb, TCA_OPTIONS, sizeof(opt), &opt);
+
+	if ( q->link )
+	{
+		ipg = q->link->attr.ipg;
+		oln = q->link->attr.oln;
+		old = q->link->attr.old;
+	}
+
+	RTA_PUT ( skb, TCA_OPTIONS, 0, NULL );
+	RTA_PUT ( skb, TCA_DWCS_DEADLINE, sizeof ( ipg ), &ipg );
+	RTA_PUT ( skb, TCA_DWCS_OLD, sizeof ( oln ), &old );
+	RTA_PUT ( skb, TCA_DWCS_OLN, sizeof ( oln ), &oln );
+
+	rta->rta_len = skb->tail - b;
+	spin_lock_bh ( &sch->dev->queue_lock );
+	if ( dwcs_copy_xstats ( skb, &q->link->stats ) )
+	{
+		spin_unlock_bh ( &sch->dev->queue_lock );
+		goto rtattr_failure;
+	}
+	spin_unlock_bh ( &sch->dev->queue_lock );
+
+	return skb->len;
+
+
+
+	return skb->len;
+
+  rtattr_failure:
+	skb_trim ( skb, b - skb->data );
+	return -1;
+}
+#endif
+
+
+
+
+/*
+ * The destroy function of a queuing discipline is used to remove 
+ * the queuing discipline.  It also removes all the classes and 
+ * filters associated with queuing discipline.
+ */
+static void
+dwcs_destroy ( struct Qdisc *sch )
+{
+	struct dwcs_sched_data *q = ( struct dwcs_sched_data * ) sch->data;
+	struct dwcs_class  *cl;
+	unsigned            h;
+
+
+	del_timer ( &q->wd_timer );
+
+#ifdef CONFIG_NET_CLS_POLICE
+	q->rx_class = NULL;
+#endif
+	for ( h = 0; h < 16; h++ )
+	{
+		for ( cl = q->classes[h]; cl; cl = cl->next )
+			dwcs_destroy_filters ( cl );
+	}
+
+	for ( h = 0; h < 16; h++ )
+	{
+		for ( cl = q->classes[h]; cl; cl = cl->next )
+			dwcs_destroy_class ( cl );
+	}
+
+#ifdef PROC_MONITORING
+	/*
+	 * Remove /proc/ file entry 
+	 */
+	// proc_unregister(&proc_root, proc_dwcs.low_ino);
+#endif
+
+	MOD_DEC_USE_COUNT;			/* indicate that the module is NOT in use */
+}
+
+
+
+
+/*
+*************************************************************
+**
+** Section for definition of class related functions.
+**
+*************************************************************
+*/
+
+
+
+/*
+** ..._graft() is to attach a new queuing discipline to a class
+*/
+static int
+dwcs_graft ( struct Qdisc *sch,
+			 unsigned long arg,
+			 struct Qdisc *new,
+			 struct Qdisc **old )
+{
+	/*
+	 * for DWCS, we can not have a _graft() function.  This is because
+	 * * when we dequeue() we frequently need to know which is the next 
+	 * * packet of class that is going to be dequeued.  If queue is not FIFO, 
+	 * * current API doesn't allow us to access the next packet.  Therefore,
+	 * * we use FIFO queues in DWCS classes and don't allow this to be changed.
+	 */
+	return -ENOENT;
+}
+
+
+/*
+**  ..._leaf() - is not described in QoS API specifications...???
+*/
+static struct Qdisc *
+dwcs_leaf ( struct Qdisc *sch,
+			unsigned long arg )
+{
+	struct dwcs_class  *cl = ( struct dwcs_class * ) arg;
+
+	return cl ? cl->q : NULL;
+}
+
+
+
+/*
+ * Helper function to return the address of the class
+ * by providing the classid (that includes major and minor ids),
+ * Returns NULL, if no class is found.
+ */
+static __inline__ struct dwcs_class *
+dwcs_class_lookup ( struct dwcs_sched_data *q,
+					u32 classid )
+{
+	struct dwcs_class  *cl;
+
+	for ( cl = q->classes[dwcs_hash ( classid )]; cl; cl = cl->next )
+		if ( cl->classid == classid )
+		{
+			return cl;
+		}
+
+	return NULL;
+}
+
+
+
+/*
+** ..._get() returns the internal ID of a class in form of a
+** pointer to corresponding dwcs class structure.
+*/
+static unsigned long
+dwcs_get ( struct Qdisc *sch,
+		   u32 classid )
+{
+	struct dwcs_sched_data *q = ( struct dwcs_sched_data * ) sch->data;
+	struct dwcs_class  *cl;
+
+	cl = dwcs_class_lookup ( q, classid );
+
+	if ( cl )
+	{
+		cl->refcnt++;
+		return ( unsigned long ) cl;
+	}
+	return 0;
+}
+
+
+static void
+dwcs_destroy_filters ( struct dwcs_class *cl )
+{
+	struct tcf_proto   *tp;
+
+	while ( ( tp = cl->filter_list ) != NULL )
+	{
+		cl->filter_list = tp->next;
+		tp->ops->destroy ( tp );
+	}
+}
+
+
+
+/*
+** ..._put() - invoked when a class previously referenced using the get() function 
+** is de-referenced.  It decrements the usage count of the class.
+*/
+static void
+dwcs_put ( struct Qdisc *sch,
+		   unsigned long arg )
+{
+	struct dwcs_sched_data *q = ( struct dwcs_sched_data * ) sch->data;
+	struct dwcs_class  *cl = ( struct dwcs_class * ) arg;
+
+
+	if ( --cl->refcnt == 0 )
+	{
+#ifdef CONFIG_NET_CLS_POLICE
+		if ( q->rx_class == cl )
+			q->rx_class = NULL;
+#endif
+		dwcs_destroy_class ( cl );
+	}
+	return;
+}
+
+
+/*
+** dwcs_link_class() inserts the class in qdisc's linked list.
+** It should be executed atomically.
+*/
+static void
+dwcs_link_class ( struct dwcs_class *this )
+{
+	struct dwcs_sched_data *q =
+		( struct dwcs_sched_data * ) this->qdisc->data;
+	unsigned            h = dwcs_hash ( this->classid );
+
+	this->next = q->classes[h];
+	q->classes[h] = this;
+
+}
+
+
+/*
+** dwcs_unlink_class() inserts the class in qdisc's linked list.
+** It should be executed atomically.
+*/
+static void
+dwcs_unlink_class ( struct dwcs_class *this )
+{
+	struct dwcs_sched_data *q =
+		( struct dwcs_sched_data * ) this->qdisc->data;
+	struct dwcs_class  *cl,
+		**clp;
+
+	/*
+	 * find the previous class in linked list 
+	 */
+	for ( clp = &q->classes[dwcs_hash ( this->classid )];
+		  ( cl = *clp ) != NULL; clp = &cl->next )
+	{
+		if ( cl == this )
+		{
+			*clp = cl->next;
+			cl->next = NULL;
+			break;
+		}
+	}
+}
+
+
+/*
+** ..._change() - is used to change the properties associated with a class.
+** It is also used to create classes at times.
+*/
+static int
+dwcs_change_class ( struct Qdisc *sch,
+					u32 classid,
+					u32 parentid,
+					struct rtattr **tca,
+					unsigned long *arg )
+{
+	int                 err;
+	struct rtattr      *opt = tca[TCA_OPTIONS - 1];
+	struct rtattr      *tb[TCA_DWCS_MAX];
+	struct dwcs_sched_data *q = ( struct dwcs_sched_data * ) sch->data;
+	struct dwcs_class  *cl = ( struct dwcs_class * ) *arg;
+
+
+	/*
+	 * Process passed parameters here - We apply them to 
+	 * * a class that is about to be created. 
+	 */
+//  if (opt==NULL ||
+	if ( rtattr_parse
+		 ( tb, TCA_DWCS_MAX, RTA_DATA ( opt ), RTA_PAYLOAD ( opt ) ) )
+		return -EINVAL;
+
+	if ( tb[TCA_DWCS_DEADLINE - 1] &&
+		 RTA_PAYLOAD ( tb[TCA_DWCS_DEADLINE - 1] ) != 4 )
+		return -EINVAL;
+
+	if ( tb[TCA_DWCS_OLN - 1] && RTA_PAYLOAD ( tb[TCA_DWCS_OLN - 1] ) != 4 )
+		return -EINVAL;
+
+
+	if ( tb[TCA_DWCS_OLD - 1] && RTA_PAYLOAD ( tb[TCA_DWCS_OLD - 1] ) != 4 )
+		return -EINVAL;
+
+	if ( tb[TCA_DWCS_FLAGS - 1] &&
+		 RTA_PAYLOAD ( tb[TCA_DWCS_FLAGS - 1] ) != 4 )
+		return -EINVAL;
+
+
+	/*
+	 * #ifdef CONFIG_NET_CLS_POLICE
+	 * if (tb[TCA_DWCS_POLICE-1] &&
+	 * RTA_PAYLOAD(tb[TCA_DWCS_POLICE-1]) < sizeof(struct tc_cbq_police))
+	 * return -EINVAL;
+	 * #endif
+	 */
+
+
+
+	/*
+	 * We don't support dynamic parameter changes. 
+	 * *  So, if classid exists, return error. Otherwise, 
+	 * *  create a new class.
+	 */
+	if ( cl || dwcs_class_lookup ( q, classid ) )
+	{							// double check
+		return -EINVAL;
+	}
+
+	if ( parentid == TC_H_ROOT )
+		return -EINVAL;
+
+	/*
+	 * make sure the parent exists 
+	 */
+	/*
+	 * parent = &q->link;
+	 * if (parentid) {
+	 * parent = dwcs_class_lookup(q, parentid);
+	 * err = -EINVAL;
+	 * if (parent == NULL)
+	 * goto failure;
+	 * }
+	 */
+
+	/*
+	 * allocate memory for a class 
+	 */
+	err = -ENOBUFS;
+	cl = kmalloc ( sizeof ( struct dwcs_class ), GFP_KERNEL );
+	if ( cl == NULL )
+		goto failure;
+
+	memset ( cl, 0, sizeof ( struct dwcs_class ) );
+
+	cl->refcnt = 1;
+	if ( !( cl->q = qdisc_create_dflt ( sch->dev, &pfifo_qdisc_ops ) ) )
+		cl->q = &noop_qdisc;
+	cl->classid = classid;
+	cl->qdisc = sch;
+
+	/*
+	 * DWCS parameters provided by the user 
+	 */
+	if ( tb[TCA_DWCS_DEADLINE - 1] )
+		cl->attr.ipg = *( long * ) RTA_DATA ( tb[TCA_DWCS_DEADLINE - 1] );
+	// cl->attr.deadline = *(long*)RTA_DATA(tb[TCA_DWCS_DEADLINE-1]);
+	if ( tb[TCA_DWCS_OLN - 1] )
+		cl->attr.oln = *( unsigned int * ) RTA_DATA ( tb[TCA_DWCS_OLN - 1] );
+	if ( tb[TCA_DWCS_OLD - 1] )
+	{
+		cl->attr.old =
+			*( unsigned int * ) RTA_DATA ( tb[TCA_DWCS_OLD - 1] );
+		if ( cl->attr.old == 0 )
+			return -EINVAL;
+	}
+	/*
+	 * process optional DWCS parameters 
+	 */
+	if ( tb[TCA_DWCS_FLAGS - 1] )
+		cl->attr.flags =
+			*( unsigned int * ) RTA_DATA ( tb[TCA_DWCS_FLAGS - 1] );
+	/*
+	 * initialization of internal DWCS attributes 
+	 */
+	cl->attr.cln = 0;			/* Current loss numerator. */
+	cl->attr.cld = 0;			/* Current loss denominator. */
+	cl->attr.droppable = FALSE;	/* TRUE if packets can be dropped */
+	cl->attr.cln = cl->attr.oln;
+	cl->attr.cld = cl->attr.old;
+	cl->attr.clt = ( ( float ) cl->attr.oln ) / cl->attr.old;
+
+
+
+	dwcs_link_class ( cl );		/* atomicaly inserts the class in a liked list */
+	q->classcount++;
+
+	*arg = ( unsigned long ) cl;
+	return 0;
+
+  failure:
+	return err;
+}
+
+
+/*
+ * a helper function to free the memory allocated by the class.  It assumes that
+ * the class has been removed from a linked list.
+ */
+static void
+dwcs_destroy_class ( struct dwcs_class *cl )
+{
+	dwcs_destroy_filters ( cl );
+	qdisc_destroy ( cl->q );
+#ifdef CONFIG_NET_ESTIMATOR
+	qdisc_kill_estimator ( &cl->stats );
+#endif
+	kfree ( cl );
+}
+
+
+
+
+/*
+** ..._delete() - is used to delete the class.
+*/
+static int
+dwcs_delete ( struct Qdisc *sch,
+			  unsigned long arg )
+{
+	struct dwcs_sched_data *q = ( struct dwcs_sched_data * ) sch->data;
+	struct dwcs_class  *cl = ( struct dwcs_class * ) arg;
+
+	if ( cl->filters || cl == ( struct dwcs_class * ) &q->link )
+		return -EBUSY;
+
+	q->classcount--;
+	dwcs_unlink_class ( cl );	/* remove the class from the linked list */
+
+	dwcs_destroy_class ( cl );
+
+	return ( 0 );
+}
+
+
+
+/*
+** ..._walk() is used to iterate over all the classes of queuing discipline 
+** and invokes a callback function for each of the classes.
+*/
+static void
+dwcs_walk ( struct Qdisc *sch,
+			struct qdisc_walker *arg )
+{
+	struct dwcs_sched_data *q = ( struct dwcs_sched_data * ) sch->data;
+	unsigned            h;
+
+	if ( arg->stop )
+		return;
+
+	for ( h = 0; h < 16; h++ )
+	{
+		struct dwcs_class  *cl;
+
+		for ( cl = q->classes[h]; cl; cl = cl->next )
+		{
+			if ( arg->count < arg->skip )
+			{
+				arg->count++;
+				continue;
+			}
+			if ( arg->fn ( sch, ( unsigned long ) cl, arg ) < 0 )
+			{
+				arg->stop = 1;
+				return;
+			}
+			arg->count++;
+		}
+	}
+}
+
+
+
+/*
+** ..._find_tcf() - used to return the anchor to the list of filters that 
+** are associated to a class.
+*/
+static struct tcf_proto **
+dwcs_find_tcf ( struct Qdisc *sch,
+				unsigned long arg )
+{
+	struct dwcs_sched_data *q = ( struct dwcs_sched_data * ) sch->data;
+	struct dwcs_class  *cl = ( struct dwcs_class * ) arg;
+
+	if ( cl == NULL )
+		cl = q->link;
+
+	return &cl->filter_list;
+}
+
+
+
+
+/*
+** ..._bind_tcf() - used to attach an instance of a filter to a class.
+** We increment the class counter for the number of filters.
+*/
+static unsigned long
+dwcs_bind_filter ( struct Qdisc *sch,
+				   unsigned long parent,
+				   u32 classid )
+{
+	struct dwcs_sched_data *q = ( struct dwcs_sched_data * ) sch->data;
+	struct dwcs_class  *cl;
+
+
+	cl = dwcs_class_lookup ( q, classid );
+
+	if ( cl )
+	{
+		cl->filters++;
+		return ( unsigned long ) cl;
+	}
+	return 0;
+}
+
+
+
+/*
+** ..._unbind() - is used to remove an instance of a filter attached to a class.
+** We need to decrement the counter for the number of filters.
+*/
+static void
+dwcs_unbind_filter ( struct Qdisc *sch,
+					 unsigned long arg )
+{
+	struct dwcs_class  *cl = ( struct dwcs_class * ) arg;
+
+
+	cl->filters--;
+}
+
+
+static int
+dwcs_dump_attr ( struct sk_buff *skb,
+				 struct dwcs_class *cl )
+{
+	int                 ipg = 0,
+		oln = 0,
+		old = 0;
+	struct rtattr      *rta = NULL;
+	unsigned char      *b = skb->tail;
+
+	rta = ( struct rtattr * ) b;
+
+	if ( cl )
+	{
+		ipg = cl->attr.ipg;
+		oln = cl->attr.oln;
+		old = cl->attr.old;
+	}
+
+	RTA_PUT ( skb, TCA_OPTIONS, 0, NULL );
+	RTA_PUT ( skb, TCA_DWCS_DEADLINE, sizeof ( ipg ), &ipg );
+	RTA_PUT ( skb, TCA_DWCS_OLD, sizeof ( oln ), &old );
+	RTA_PUT ( skb, TCA_DWCS_OLN, sizeof ( oln ), &oln );
+
+	return skb->len;
+
+  rtattr_failure:
+	return -1;
+
+}
+
+/*
+** ..._dump_class() - is used to dump diagnostic data about the class.
+*/
+static int
+dwcs_dump_class ( struct Qdisc *sch,
+				  unsigned long arg,
+				  struct sk_buff *skb,
+				  struct tcmsg *tcm )
+{
+
+	struct dwcs_class  *cl = ( struct dwcs_class * ) arg;
+	unsigned char      *b = skb->tail;
+	struct rtattr      *rta = ( struct rtattr * ) b;
+
+
+	if ( !cl )
+		return -1;
+
+	tcm->tcm_handle = TC_H_MAKE ( TC_H_MAJ ( sch->handle ), arg - 1 );
+	tcm->tcm_handle = cl->classid;
+	if ( dwcs_dump_attr ( skb, cl ) < 0 )
+		goto rtattr_failure;
+
+	rta->rta_len = skb->tail - b;
+
+	return skb->len;
+
+  rtattr_failure:
+	skb_trim ( skb, b - skb->data );
+	return -1;
+
+	/*
+	 * Magic will go here 
+	 */
+	return -1;
+
+}
+
+
+static struct Qdisc_class_ops dwcs_class_ops = {
+	dwcs_graft,
+	dwcs_leaf,
+	dwcs_get,
+	dwcs_put,
+	dwcs_change_class,
+	dwcs_delete,
+	dwcs_walk,
+
+	dwcs_find_tcf,
+	dwcs_bind_filter,
+	dwcs_unbind_filter,
+
+#ifdef CONFIG_RTNETLINK
+	dwcs_dump_class,
+#endif
+
+};
+
+struct Qdisc_ops    dwcs_qdisc_ops = {
+	NULL,
+	&dwcs_class_ops,
+	"dwcs",
+	sizeof ( struct dwcs_sched_data ),
+
+	dwcs_enqueue,
+	dwcs_dequeue,
+	dwcs_requeue,
+	dwcs_drop,
+
+	dwcs_init,
+	dwcs_reset,
+	dwcs_destroy,
+	dwcs_init,					/* technically, should be dwcs_change() */
+
+#ifdef CONFIG_RTNETLINK
+	dwcs_dump,
+#endif
+};
+
+/*
+ * If we are compiling this as a module, then we need to define the
+ * following two functions.
+ */
+#ifdef MODULE
+int
+init_module ( void )
+{
+	pidcall = sys_call_table[__NR_getpid];
+	return register_qdisc ( &dwcs_qdisc_ops );
+}
+
+void
+cleanup_module ( void )
+{
+	unregister_qdisc ( &dwcs_qdisc_ops );
+}
+#endif
+
+
+
+
+/* -------------------------------------------------------
+ *  If specified, we create /proc/ entry for monitoring 
+ *  the scheduler.
+ */
+#ifdef PROC_MONITORING
+
+/* Create an entry in /proc for accessing DWCS state information. */
+
+/*
+struct proc_dir_entry proc_dwcs = {
+        0,                 // low_ino: the inode -- dynamic 
+        8, "sch_dwcs",     // len of name and name 
+        S_IFREG | S_IRUGO, // mode
+        1, 0, 0,           // nlinks, owner, group
+        0, NULL,           // size - unused; operations - use default ops
+        &proc_read_dwcs,   // function used to read data
+	// nothing more
+    };
+*/
+
+int
+proc_read_dwcs ( char *buf,
+				 char **start,
+				 off_t offset,
+				 int length,
+				 int *eof,
+				 void *data )
+{
+	int                 len;
+
+	/*
+	 * Display runqueue statistics. 
+	 */
+	len = sprintf ( buf, "Jiffies=%lu Current=%d Prev=%d Next=%d\n\n",
+					jiffies, -1, -1, -1 );
+	len -= offset;
+	if ( len > length )
+		len = length;
+	else
+		len = 0;
+
+	*start = buf + offset;
+	*eof = 1;
+
+	return len;
+}
+#endif
+MODULE_LICENSE("GPL");
